               page    54,121
               .286
               .286p


_TEXT           SEGMENT para PUBLIC 'CODE'
                assume  CS:_TEXT,DS:_TEXT,SS:_TEXT,ES:_TEXT
                ORG     100h
START:		JMP	INITIALIZE
PROGRAM         DB      13,'WKB Keyboard Lock Utility Release 1.31 loaded',13,10
                DB      '(c) 1990 Walter Stwora    All Rights Reserved',13,10,10
                DB      'The Hot Key is '
HOT_KEY_TEXT    DB      'CTRL-L      ',13,10,'$'
HOT_KEY         DB      26H                   ; Scan code for Letter L
CTRL_KEY_T      DB      00000100B             ; CTRL
W_PSWD2         DB      02,02,02
                DB      6 DUP (0)
BOOT_KEY        DB      53H                   ; Scan code for DEL
LEFT_SHIFT      EQU     00000010B             ; Left Shift
RIGHT_SHIFT     EQU     00000001B             ; Right Shift
CTRL_KEY        EQU     00000100B             ; CTRL
ALT_KEY         EQU     00001000B             ; ALT
SWITCH          DB      0
NO_ENTRY        EQU     00000001B
TIME_EXPIRED    EQU     00000100B
ACTIVE          EQU     00000010B
TIME_COUNTER    DW      0
SET_COUNTER     DW      (60*18)
OLD_INT_9h      DD      0
OLD_INT_1Ch     DD      0
W_PSWD          DB      9 DUP (?)
;
;-----------------MAIN------------------------------------
;
MAIN            PROC    Far
                ASSUME  CS:_TEXT,DS:NOTHING,ES:NOTHING,SS:NOTHING
                PUSHF
                STI
                PUSH    AX

                MOV     AX,word Ptr SET_COUNTER
                MOV     word Ptr TIME_COUNTER,AX

                IN      AL,60h          ;Get scan code from keyboard

                TEST    SWITCH,NO_ENTRY
                JZ      CHECK_KEY
                TEST    AL,80h          ;Check for break code
                JNZ     OUT1
                CALL    click           ;Click on make code
                CMP     AL,BOOT_KEY    ; Was DEL key pressed ?
                JNE     OUT1
                MOV     AH,02h        ;Check ALT + CTRL
                INT     16h
                TEST    AL,CTRL_KEY
                JZ      OUT1           ; NO CTRL pressed, exit
                TEST    AL,ALT_KEY
                JZ      OUT1

                CALL    KB_RESET       ; Bypass CTRL-ALT-DL
                JMP     OUT2          ; and exit

CHECK_KEY:
                TEST    SWITCH,TIME_EXPIRED
                JNZ     LOCK_IT
                CMP     AL,HOT_KEY      ;Check for 'L'
                JNE     OUT1            ;No, then exit.
                MOV     AH,02h        ;Check shift key.
                INT     16h
                TEST    AL,CTRL_KEY_T
                JZ      OUT1           ; NO CTRL pressed, exit
LOCK_IT:
                CALL    KB_RESET       ; Bypass CTRL-SHIFT-L
                OR      SWITCH,NO_ENTRY
                CALL    WAIT_FOR_PSW
OUT2:
                POP     AX
                POPF
                IRET

OUT1:
                POP     AX
                POPF
                JMP     CS:OLD_INT_9h
MAIN            ENDP
;
;---------------Keyboard Reset----------------------;
;
KB_RESET	PROC	NEAR
		IN	AL,61h		;Get current control port value.
		MOV	AH,AL		;Save it in AH.
		OR	AL,80h		;Set bit 7.
		OUT	61h,AL		;send reset value.
		MOV	AL,AH		;Restore original value.
		OUT	61h,AL		;Send it out to enable keyboard.
		CLI			;Suspend interrupts.
		MOV	AL,20h		;Get EOI value.
		OUT	20h,AL		;Send EOI to 8259.
		STI
		RET
KB_RESET        ENDP
;
;----------------wait for psw
;
WAIT_FOR_PSW    PROC    Near
                TEST    SWITCH,ACTIVE
                JNZ     WAIT_FOR_PSW_EX
                OR      SWITCH,ACTIVE

REPEAT_PSW:
                CALL    CHECK_PSW
                JNZ     REPEAT_PSW
                AND     SWITCH,not (NO_ENTRY+ACTIVE+TIME_EXPIRED)
WAIT_FOR_PSW_EX:
                RET
WAIT_FOR_PSW    ENDP

;
;---------------CHECK_PSW--------------------------;
;
CHECK_PSW       PROC
                PUSHA
                PUSH    DS
                PUSH    ES
                PUSH    CS
                POP     DS
                ASSUME  DS:_TEXT
                CALL    GET_PSWD
                MOV     DI,offset W_PSWD  ;ES:DI output
                MOV     SI,offset W_PSWD2 ;DS:SI input

                MOV     CX,BX                  ;Length in BX
                REPE    CMPSB
                POP     ES
                POP     DS
                POPA
                RET
CHECK_PSW       ENDP
;----------------------------------------------------------
GET_PSWD        PROC
                MOV     CX,8           ;length into CX
                PUSH    CS
                POP     ES
                MOV     DI,offset W_PSWD  ;ES:DI output
                CLD                             ;All string operations forward.
                MOV     BX,0
READ_CHAR:
                CALL    GET_CHAR        ;Read character from keyboard
                xchg    AL,AH
                CMP     AL,1Ch          ;Enter ?
                JE      GET_PSWD_EX
                STOSB
                INC     BX
                LOOP    READ_CHAR
GET_PSWD_EX:
                MOV     AL,0
                STOSB
                INC     BX
                RET
GET_PSWD        ENDP

;
;---------------GET_CHAR----------------------------;
;
GET_CHAR        PROC    NEAR
                XOR     AX,AX
                MOV     AH,00H
                INT     16h             ;AH = Scan,      AL = Character
                RET
GET_CHAR        ENDP    
                ASSUME  DS:NOTHING
;---------------------------------------------------------------------
; CLICK programs the speaker to produce a short click.
;---------------------------------------------------------------------
CLICK           PROC    NEAR
                PUSH    AX
                MOV     AL,0B6H                 ;Program timer 2 to generate
                OUT     43H,AL                  ;  pulses
                JMP     short $+2
                MOV     AL,0                    ;Send low byte of the 16-bit
                OUT     42H,AL                  ;  value that will determine
                JMP     short $+2               ;  the pulse frequency
                MOV     AL,6                    ;Then send the high byte
                OUT     42H,AL
                JMP     short $+2
                IN      AL,61h                  ;Speaker on
                JMP     short $+2
                OR      AL,3
                OUT     61H,AL
                PUSH    CX                      ;Save CX
                MOV     CX,600h                ;Timing delay
HERE:           LOOP    HERE
                POP     CX                      ;Restore CX
                IN      AL,61H                  ;Speaker off
                JMP     short $+2
                AND     AL,0FCh
                OUT     61H,AL
                POP     AX
                RET                             ;Return to caller
CLICK           ENDP

;---------------------INT 1Ch ------------------------
MY_INT_1Ch     PROC     Far

               DEC      TIME_COUNTER
               JNZ      EXIT_MY_INT_1Ch
OR_STMT:
               OR       SWITCH,TIME_EXPIRED

EXIT_MY_INT_1Ch:
               JMP      CS:OLD_INT_1Ch
MY_INT_1Ch     ENDP

;-------------------Initialize------------------------;
;
;--------------------------------------------------------------------;
; Search memory for a copy of our code, to see if already installed. ;
;--------------------------------------------------------------------;

INITIALIZE     PROC    NEAR
               PUSH    CS
               POP     DS
               ASSUME  DS:_TEXT
               CLD                             ;All string operations forward.
               MOV     BX,OFFSET START         ;Point to start of code.
               NOT     BYTE PTR [BX]           ;Change a byte so no false match.
               XOR     DX,DX                   ;Start at segment zero.
               MOV     AX,CS                   ;Store our segment in AX.
NEXT_PARAG:    INC     DX                      ;Next paragraph.
               MOV     ES,DX
               CMP     DX,AX                   ;Is it our segment?
               JZ      CHECK_PARM              ;If yes, search is done.
               MOV     SI,BX                   ;Else, point to our signature.
               MOV     DI,BX                   ; and offset of possible match.
               MOV     CX,16                   ;Check 16 bytes for match.
               REP     CMPSB
               JNZ     NEXT_PARAG              ;If no match, keep looking.

;------------------------------------------------;

                OR      CS:SWITCHES4,FOUND_IN_MEM   ;Trigger FOUND!

;------------------------------------------------;

;
;check for parameters
;
CHECK_PARM:
                CLD
                MOV     SI,81H          ;Point to command line

NEXT_CAP:       LODSB
                CMP     AL,13d          ;Enter ?
                JNZ     CHECK_LOM
                JMP     END_CAP          ;  Yes - end of parameters
CHECK_LOM:
                CMP     AL,"/"          ;  Is it / ?
                JNE     NEXT_CAP

TEST_PARM:      LODSB
                CMP     AL,13d          ;  Enter ?
                JZ      END_CAP
                AND     al,11011111b    ; Convert key to uppercase
                CMP     AL,"Q"          ;  Is it Q ?
                JE      R_UNINST
                CMP     AL,"U"          ;  Is it U ?
                JNE     NEXT_C1
R_UNINST:
                OR      CS:SWITCHES4,UNINSTALL
                JMP     short END_CAP
NEXT_C1:
                CMP     AL,"T"          ; Time set
                JNE     END_LOOP
                LODSB                   ; Get Minutes
                CMP     AL,13d          ; If missing, exit
                JE      END_CAP
                CMP     AL,"-"
                JE      RESET_TIME
                MOV     Byte Ptr T_MSG,AL
                SUB     AL,48d          ; Make bin number
                MOV     AH,0
                MUL     WORD Ptr SET_COUNTER
                MOV     Word Ptr SET_COUNTER,AX
                OR      SWITCHES4,TIMER_SET
END_LOOP:
                JMP     short NEXT_CAP  ; Read next
RESET_TIME:
                MOV     AL,90h          ; Load Instr NOP
                MOV     CX,6            ; 6 times
                MOV     DI,offset OR_STMT
                PUSH    CS
                POP     ES               ; ES:DI output
                REP     STOSB            ; Replace OR by NOP
                MOV     SWITCHES4,TIMER_SUPRESSED
                JMP     short END_LOOP
END_CAP:
                TEST    CS:SWITCHES4,UNINSTALL+FOUND_IN_MEM
                JNZ     END_CAP_2
                JMP     CHECK_VER       ; Go to make TSR if NOT find & No Unin.
END_CAP_2:
                TEST    CS:SWITCHES4,UNINSTALL
                JNZ     TRY_UNINSTALL

                MOV     DX,offset MESSAGE1   ;Already in memory
                MOV     AH,9
                INT     21H

BAY_BAY:        MOV     AX,4C01h        ; Exit with return code 1
                INT     21h

TRY_UNINSTALL:
                TEST    CS:SWITCHES4,FOUND_IN_MEM
                JNZ     DO_U
                MOV     DX,offset MESSAGE3 ;Display NOTHING TO UNINSTALL
                JMP     short DISP_EXIT

DO_U:
                MOV     CX,ES
; Reset INT 09
                MOV     AX,3509h        ;Get interrupt 09
                INT     21h
                CMP     BX,offset MAIN ;Has it been hooked by an?
                JNE     UNINSTALL_ERROR
                MOV     BX,ES
                CMP     BX,CX
                JNZ     UNINSTALL_ERROR

                MOV     DX,word Ptr ES:OLD_INT_9H[0]
                MOV     DS,word Ptr ES:OLD_INT_9H[2]
                MOV     AX,2509h
                INT     21h

; Reset INT 1Ch
                MOV     AX,351Ch        ;Get interrupt 09
                INT     21h
                CMP     BX,offset MY_INT_1Ch ;Has it been hooked by an?
                JNE     UNINSTALL_ERROR
                MOV     BX,ES
                CMP     BX,CX
                JNZ     UNINSTALL_ERROR

                MOV     DX,word Ptr ES:OLD_INT_1CH[0]
                MOV     DS,word Ptr ES:OLD_INT_1CH[2]
                MOV     AX,251Ch
                INT     21h

                MOV     AH,49H          ;Return memory
                INT     21h
                JC      UNINSTALL_ERROR_2

;
;Deallocate the program's environment block.
;
                PUSH    ES
                POP     DS
                MOV     AX,DS:[2Ch]             ;get environment segment
                MOV     ES,AX
                MOV     AH,49H                  ;free it
                INT     21H

                PUSH    CS
                POP     DS
                MOV     DX,offset MESSAGE2 ;Display UNINSTALLED
DISP_EXIT:
                MOV     AH,9
                INT     21H
                MOV     AX,4C00h        ; Exit with return code 0
                INT     21h

UNINSTALL_ERROR:
                MOV     DX,offset MESSAGE4      ;Sorry, can't uninstall
                JMP     short DISP_EXIT
UNINSTALL_ERROR_2:
                MOV     DX,offset MESSAGE5      ;Memory release error
                JMP     short DISP_EXIT
;******************************************************************
CHECK_VER:
                MOV     AH,30H                   ; Get DOS version
                INT     21H
                CMP     AL,2                  ; Requires DOS 2.0
                JGE     VERSION_OK
                MOV     DX,offset ERR1                   ;   else error and quit
                MOV     AL,9
                INT     21H
                INT     20h

VERSION_OK:

               MOV     DX,OFFSET PROGRAM       ;Display our signature.
               MOV     AH,9
               INT     21h
               TEST    SWITCHES4,TIMER_SET
               JZ      CHECK_TIM
               MOV     DX,offset MESSAGE6 ;Display "Timer set"
               MOV     AH,9
               INT     21H
CHECK_TIM:
               TEST    SWITCHES4,TIMER_SUPRESSED
               JZ      SET_SWTCH
               MOV     DX,offset MESSAGE8 ;Display "Timer suppresed"
               MOV     AH,9
               INT     21H
SET_SWTCH:                             ; INT 9

                MOV     AH,35h          ;Get current interr. 9 vector,
                MOV     AL,9            ;  save it, then replace it with
                INT     21h             ;  my own.
                MOV     word Ptr OLD_INT_9H,BX
                MOV     word Ptr OLD_INT_9H[2],ES
                MOV     AH,25h
                MOV     AL,9
                MOV     DX,offset MAIN
                INT     21h

                                        ; INT 1Ch

                MOV     AH,35h          ;Get current interr. 9 vector,
                MOV     AL,1Ch          ;  save it, then replace it with
                INT     21h             ;  my own.
                MOV     word Ptr OLD_INT_1CH,BX
                MOV     word Ptr OLD_INT_1CH[2],ES
                MOV     AH,25h
                MOV     AL,1Ch
                MOV     DX,offset MY_INT_1Ch
                INT     21h
;
;Exit by TSR int 21h
;
                MOV     DX,(offset INITIALIZE - offset _TEXT + 15) SHR 4
                MOV     AX,3100h
                INT     21h
;
;---------------------------------------------------------;
;
SWITCHES4       DB      0
UNINSTALL       EQU     00000001B
FOUND_IN_MEM    EQU     00000010B
TIMER_SET       EQU     00000100B
TIMER_SUPRESSED EQU     00001000B
MESSAGE1        DB      13,10,'Program is already loaded.',13,10,'$'
MESSAGE3        DB      13,10,'There is nothing to unistall.',13,10,'$'
MESSAGE5        DB      13,10,'Memory can not be released',13,10,'$'
MESSAGE7        DB      13,10
MESSAGE2        DB      'WKB Uninstalled',13,10,'$'
MESSAGE4        DB      13,10,"WKB can't be uninstalled",13,10
                DB      'Uninstall resident programs in reverse order',13,10,'$'
MESSAGE6        DB      13,10,'Timer set at '
T_MSG           DB      ?
                DB      ' Minutes',13,10,'$'
MESSAGE8        DB      13,10,'Timer Suppressed',13,10,'$'
ERR1            DB      'Improper Version',13,10,'$'
INITIALIZE      ENDP
_TEXT		ENDS
		END	START
